//+------------------------------------------------------------------+
//|                                                        Entry.mq4 |
//|                        Copyright 2022, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2022, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
extern double Risk_to_Reward = 2;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {   
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   ObjectsDeleteAll();     
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {   
  }
//+------------------------------------------------------------------+
//| On chart event                                                   |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,         // Event identifier   
                  const long& lparam,   // Event parameter of long type 
                  const double& dparam, // Event parameter of double type 
                  const string& sparam) // Event parameter of string type 
 {
  long chart_ID = ChartFirst();
  chart_ID = 0;
  {
   static ulong clickTimeMemory;
   
   if(id == CHARTEVENT_CLICK)
   { 
    ulong clickTime = GetTickCount();
    if(clickTime < clickTimeMemory + 300)
    {
     ChartClean();
     
     datetime time = 0;
     double price = 0;
     int window = 0;
     if (ChartXYToTimePrice(ChartID(),int(lparam),int(dparam),window,time,price))
      {        
       int bar = iBarShift(Symbol(),Period(),time);     
       double HighPrice = iHigh(Symbol(),Period(),bar);
       double LowPrice = iLow(Symbol(),Period(),bar); 
       double Risk = HighPrice - LowPrice;  
       datetime StartTime = iTime(Symbol(),Period(),bar);
       
       ObjectCreate("EntryHLine", OBJ_HLINE , 0, iTime(Symbol(),0,0), HighPrice);
       ObjectSet("EntryHLine", OBJPROP_STYLE, STYLE_DASH);
       ObjectSet("EntryHLine", OBJPROP_COLOR, Blue);
       ObjectSet("EntryHLine", OBJPROP_WIDTH, 0);  
       
       ObjectCreate(chart_ID, "EntryButton", OBJ_BUTTON, 0, 0, 0);
       ObjectSetText("EntryButton", "Entry: " + string(HighPrice), 11, "Cambria", Black);     
       ObjectSet("EntryButton", OBJPROP_XDISTANCE, HighPrice);       
       ObjectSet("EntryButton", OBJPROP_YDISTANCE, StartTime);
       ObjectSetInteger(0, "EntryButton", OBJPROP_XSIZE, 100);
       ObjectSetInteger(0, "EntryButton", OBJPROP_YSIZE, 20);       
       ObjectSetInteger(0, "EntryButton", OBJPROP_BGCOLOR, Blue);
       ObjectSetInteger(0, "EntryButton", OBJPROP_COLOR, White);          
     
       ObjectCreate("StopLossHLine", OBJ_HLINE , 0, 0, LowPrice);
       ObjectSet("StopLossHLine", OBJPROP_STYLE, STYLE_DASH);
       ObjectSet("StopLossHLine", OBJPROP_COLOR, Red);
       ObjectSet("StopLossHLine", OBJPROP_WIDTH, 0); 
     
       ObjectCreate("TakeProfitHLine", OBJ_HLINE , 0, 0, HighPrice+(Risk_to_Reward*Risk));
       ObjectSet("TakeProfitHLine", OBJPROP_STYLE, STYLE_DASH);
       ObjectSet("TakeProfitHLine", OBJPROP_COLOR, Green);
       ObjectSet("TakeProfitHLine", OBJPROP_WIDTH, 0);       
      }    
       clickTimeMemory = 0;
    }
       else
       clickTimeMemory = clickTime;    
   }
       else if(id == CHARTEVENT_MOUSE_MOVE){}
       else if(id == CHARTEVENT_KEYDOWN)
   {
       return;
   }
  }

 }  
//+------------------------------------------------------------------+
//| Chart clean                                                      |
//+------------------------------------------------------------------+  
void ChartClean()
 {   
  ObjectDelete("EntryHLine");
  ObjectDelete("StopLossHLine");
  ObjectDelete("TakeProfitHLine"); 
  ObjectDelete("EntryButton");  
  Comment("");
 }  